您的位置:首页 > 其它

codeforces 839C Journey(图的遍历)

2017-08-13 13:46 148 查看
题目传送门

There are n cities and n - 1 roads in the Seven Kingdoms, each road connects two cities and we can reach any city from any other by the roads.

Theon and Yara Greyjoy are on a horse in the first city, they are starting traveling through the roads. But the weather is foggy, so they can’t see where the horse brings them. When the horse reaches a city (including the first one), it goes to one of the cities connected to the current city. But it is a strange horse, it only goes to cities in which they weren’t before. In each such city, the horse goes with equal probabilities and it stops when there are no such cities.

Let the length of each road be 1. The journey starts in the city 1. What is the expected length (expected value of length) of their journey? You can read about expected (average) value by the link https://en.wikipedia.org/wiki/Expected_value.

Input

The first line contains a single integer n (1 ≤ n ≤ 100000) — number of cities.

Then n - 1 lines follow. The i-th line of these lines contains two integers ui and vi (1 ≤ ui, vi ≤ n, ui ≠ vi) — the cities connected by the i-th road.

It is guaranteed that one can reach any city from any other by the roads.

Output

Print a number — the expected length of their journey. The journey starts in the city 1.

Your answer will be considered correct if its absolute or relative error does not exceed 10 - 6.

Namely: let’s assume that your answer is a, and the answer of the jury is b. The checker program will consider your answer correct, if .

Examples

input

4

1 2

1 3

2 4

output

1.500000000000000

input

5

1 2

1 3

3 4

2 5

output

2.000000000000000

Note

In the first sample, their journey may end in cities 3 or 4 with equal probability. The distance to city 3 is 1 and to city 4 is 2, so the expected length is 1.5.

In the second sample, their journey may end in
4000
city 4 or 5. The distance to the both cities is 2, so the expected length is 2.

题意就是给你一个n个点的树,然后然你判断到每个叶子节点的期望。

因为有n-1条边,所以每个叶子节点只会有一条边与它相连,所以只要dfs一边,然后纪录一下到这个点得长度,以及概率就可以了,注意一下,如果这个点不是根节点,那么计算这个与这个节点相邻的点的概率要减去1,因为这个点一定是由一个点扩展而来的。比如样例1,到2这个几点的概率是1/2,然后再扩展4这个节点概率就是1/(2-1),2是与2这个节点相邻的节点个数

代码如下:

#include<iostream>
#include<cstdio>
#include<cmath>
#include<cstring>
#include<vector>
#include<algorithm>

using namespace std;
const int MAX_V = 100010;
vector<int> G[MAX_V];
bool used[MAX_V];
int n;
double res;
void dfs(int x,double y,int dis){
if(G[x].size() == 1 && x != 1){
res += dis*y;
return;
}
int Size = (int)G[x].size();
for(int i=0;i<Size;i++){
int k = G[x][i];
if(!used[k]){
used[k] = true;
if(x == 1)  dfs(k,y*1/Size,dis+1);
else    dfs(k,y*1/(Size-1),dis+1);
}
}
}
int main(void){
scanf("%d",&n);
int x,y;
for(int i=1;i<n;i++){
scanf("%d %d",&x,&y);
G[x].push_back(y);
G[y].push_back(x);
}
memset(used,false,sizeof(used));
used[1] = true;res = 0;
dfs(1,1,0);

printf("%.15lf",res);

return 0;
}


昨天sb,高考之后,已经把期望值忘记是啥了,用到每个几点得总长度除以叶子节点得个数,,当然sb了,,哎,,
内容来自用户分享和网络整理,不保证内容的准确性,如有侵权内容,可联系管理员处理 点击这里给我发消息
标签: